#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <string.h>

#include "cdr.h"
#include "interface.h"
#include "support.h"

char *ReadModeNames[] = {
	"Normal (No Cache)",
	"Threaded - Faster (With Cache)",
};

GtkWidget *ConfDlg;
GtkWidget *Edit;
GtkWidget *Combo;
GtkWidget *WSubQ;
GtkWidget *SpinC;
GtkWidget *SpinS;
GList *glist;

void OnConf_Ok() {
	char *tmp;
	int i;

	tmp = gtk_entry_get_text(GTK_ENTRY(Edit));
	strcpy(CdromDev, tmp);

	tmp = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(Combo)->entry));
	for (i = 0; i < READ_MODES; i++)
		if (!strcmp(ReadModeNames[i], tmp))
			ReadMode = i;

	UseSubQ = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(WSubQ));

	CacheSize = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(SpinC));
	CdrSpeed  = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(SpinS));

	gtk_widget_destroy(ConfDlg);

	SaveConf();
	gtk_main_quit();
}

void OnConf_Cancel() {
	gtk_widget_destroy(ConfDlg);
	gtk_main_quit();
}

long CDRconfigure() {
	int i;

	LoadConf();

	ConfDlg = create_Config();

	Combo = lookup_widget(ConfDlg, "GtkCombo_Mode");
	Edit  = lookup_widget(ConfDlg, "GtkEntry_Dev");
	WSubQ = lookup_widget(ConfDlg, "GtkCheckButton_SubQ");
	SpinC = lookup_widget(ConfDlg, "GtkSpinButton_CacheSize");
	SpinS = lookup_widget(ConfDlg, "GtkSpinButton_CdrSpeed");

	gtk_entry_set_text(GTK_ENTRY(Edit), CdromDev);

	glist = NULL;
	for (i = 0; i < READ_MODES; i++)
		glist = g_list_append(glist, ReadModeNames[i]);
	gtk_combo_set_popdown_strings(GTK_COMBO(Combo), glist);
	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(Combo)->entry), ReadModeNames[ReadMode]);

	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(WSubQ), UseSubQ);

	gtk_spin_button_set_value(GTK_SPIN_BUTTON(SpinC), (float)CacheSize);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(SpinS), (float)CdrSpeed);

	gtk_widget_show_all(ConfDlg);
	gtk_main();

	return 0;
}

GtkWidget *About;

void OnAbout_Ok() {
	gtk_widget_destroy(About);
	gtk_main_quit();
}

void CDRabout() {

	About = create_About();

	gtk_widget_show_all(About);
	gtk_main();
}

int main(int argc, char *argv[]) {
	if (argc != 2) return 0;

	gtk_init(NULL, NULL);

	if (!strcmp(argv[1], "configure")) {
		CDRconfigure();
	} else {
		CDRabout();
	}

	return 0;
}
